libgimpprint API Reference: print-canon.c File Reference

Main Page | Modules | Alphabetical List | Data Structures | File List | Data Fields | Globals | Related Pages

# src/main/print-canon.c File Reference

`#include <gimp-print/gimp-print.h>`
`#include "gimp-print-internal.h"`
`#include <gimp-print/gimp-print-intl-internal.h>`
`#include <string.h>`
`#include <stdio.h>`
`#include <stdarg.h>`

Go to the source code of this file.

## Data Structures
struct | canon_dot_sizes
struct | canon_densities
struct | canon_variable_ink
struct | canon_variable_inkset
struct | canon_variable_inklist
struct | canon_caps
struct | canon_privdata_t
struct | canon_res_t
struct | paper_t
struct | canon_init_t
struct | float_param_t
## Defines
#define | CHAR_BIT 8
#define | MAX_CARRIAGE_WIDTH 13 /* This really needs to go away */
#define | MAX_PHYSICAL_BPI 1440
#define | MAX_OVERSAMPLED 8
#define | MAX_BPP 4
#define | COMPBUFWIDTH
#define | MIN(a, b) (((a)<(b)) ? (a) : (b))
#define | MAX(a, b) ((a) > (b) ? (a) : (b))
#define | USE_3BIT_FOLD_TYPE 323
#define | DECLARE_INK(name, density)
#define | SHADE(density, name) { density, sizeof(name)/sizeof(stp_dotsize_t), name }
#define | CANON_INK_K 1
#define | CANON_INK_CMY 2
#define | CANON_INK_CMYK 4
#define | CANON_INK_CcMmYK 8
#define | CANON_INK_CcMmYyK 16
#define | CANON_INK_BLACK_MASK (CANON_INK_K|CANON_INK_CMYK|CANON_INK_CcMmYK)
#define | CANON_INK_PHOTO_MASK (CANON_INK_CcMmYK|CANON_INK_CcMmYyK)
#define | CANON_SLOT_ASF1 1
#define | CANON_SLOT_ASF2 2
#define | CANON_SLOT_MAN1 4
#define | CANON_SLOT_MAN2 8
#define | CANON_CAP_DMT 0x01ul /* Drop Modulation Technology */
#define | CANON_CAP_MSB_FIRST 0x02ul /* how to send data */
#define | CANON_CAP_a 0x04ul
#define | CANON_CAP_b 0x08ul
#define | CANON_CAP_q 0x10ul
#define | CANON_CAP_m 0x20ul
#define | CANON_CAP_d 0x40ul
#define | CANON_CAP_t 0x80ul
#define | CANON_CAP_c 0x100ul
#define | CANON_CAP_p 0x200ul
#define | CANON_CAP_l 0x400ul
#define | CANON_CAP_r 0x800ul
#define | CANON_CAP_g 0x1000ul
#define | CANON_CAP_ACKSHORT 0x2000ul
#define | CANON_CAP_STD0
#define | CANON_CAP_STD1
#define | CANON_MODES(A) 0
#define | CANON_INK(A) A,sizeof(A)/sizeof(canon_variable_inklist_t*)
#define | PUT(WHAT, VAL, RES)
#define | ESC28 "\033\050"
#define | ESC5b "\033\133"
#define | ESC40 "\033\100"
#define | stp_module_version print_canon_LTX_stp_module_version
#define | stp_module_data print_canon_LTX_stp_module_data
## Typedefs
typedef canon_dot_sizes | canon_dot_size_t
typedef canon_densities | canon_densities_t
typedef canon_variable_ink | canon_variable_ink_t
typedef canon_variable_inkset | canon_variable_inkset_t
typedef canon_variable_inklist | canon_variable_inklist_t
typedef canon_variable_inklist_t * | canon_variable_inklist_p
typedef canon_caps | canon_cap_t
## Enumerations
enum | colormode_t { COLOR_MONOCHROME = 1, COLOR_CMY = 3, COLOR_CMYK = 4, COLOR_CCMMYK = 6, COLOR_CCMMYYK = 7 }
## Functions
| DECLARE_INK (canon_Cc_1bit, 0.75)
| DECLARE_INK (canon_Mm_1bit, 0.75)
| DECLARE_INK (canon_X_2bit, 1.0)
| DECLARE_INK (canon_Xx_2bit, 1.0)
| DECLARE_INK (canon_X_3bit, 1.0)
| DECLARE_INK (canon_Xx_3bit, 1.0)
void | canon_write_line (stp_vars_t *v)
const paper_t * | get_media_type (const char *name)
const canon_cap_t * | canon_get_model_capabilities (int model)
int | canon_source_type (const char *name, const canon_cap_t *caps)
int | canon_printhead_type (const char *name, const canon_cap_t *caps)
colormode_t | canon_printhead_colors (const char *name, const canon_cap_t *caps)
unsigned char | canon_size_type (const stp_vars_t *v, const canon_cap_t *caps)
int | canon_res_code (const canon_cap_t *caps, int xdpi, int ydpi)
int | canon_ink_type (const canon_cap_t *caps, int res_code)
const char * | canon_lum_adjustment (int model)
const char * | canon_hue_adjustment (int model)
const char * | canon_sat_adjustment (int model)
double | canon_density (const canon_cap_t *caps, int res_code)
const canon_variable_inkset_t * | canon_inks (const canon_cap_t *caps, int res_code, int colors, int bits)
void | canon_describe_resolution (const stp_vars_t *v, int *x, int *y)
const char * | canon_describe_output (const stp_vars_t *v)
stp_parameter_list_t | canon_list_parameters (const stp_vars_t *v)
void | canon_parameters (const stp_vars_t *v, const char *name, stp_parameter_t *description)
void | internal_imageable_area (const stp_vars_t *v, int use_paper_margins, int *left, int *right, int *bottom, int *top)
void | canon_imageable_area (const stp_vars_t *v, int *left, int *right, int *bottom, int *top)
void | canon_limit (const stp_vars_t *v, int *width, int *height, int *min_width, int *min_height)
void | canon_cmd (const stp_vars_t *v, const char *ini, const char cmd, int num,...)
void | canon_init_resetPrinter (const stp_vars_t *v, canon_init_t *init)
void | canon_init_setPageMode (const stp_vars_t *v, canon_init_t *init)
void | canon_init_setDataCompression (const stp_vars_t *v, canon_init_t *init)
void | canon_init_setColor (const stp_vars_t *v, canon_init_t *init)
void | canon_init_setResolution (const stp_vars_t *v, canon_init_t *init)
void | canon_init_setPageMargins (const stp_vars_t *v, canon_init_t *init)
void | canon_init_setTray (const stp_vars_t *v, canon_init_t *init)
void | canon_init_setPrintMode (const stp_vars_t *v, canon_init_t *init)
void | canon_init_setPageMargins2 (const stp_vars_t *v, canon_init_t *init)
void | canon_init_setPageID (const stp_vars_t *v, canon_init_t *init)
void | canon_init_setX72 (const stp_vars_t *v, canon_init_t *init)
void | canon_init_setImage (const stp_vars_t *v, canon_init_t *init)
void | canon_init_printer (const stp_vars_t *v, canon_init_t *init)
void | canon_deinit_printer (const stp_vars_t *v, canon_init_t *init)
int | canon_start_job (const stp_vars_t *v, stp_image_t *image)
int | canon_end_job (const stp_vars_t *v, stp_image_t *image)
void | canon_advance_buffer (unsigned char *buf, int len, int num)
void | setup_column (canon_privdata_t *privdata, int col, int buf_length)
void | canon_printfunc (stp_vars_t *v)
double | get_double_param (stp_vars_t *v, const char *param)
void | set_ink_ranges (stp_vars_t *v, const canon_variable_ink_t *ink, int color, const char *channel_param, const char *subchannel_param)
int | canon_do_print (stp_vars_t *v, stp_image_t *image)
int | canon_print (const stp_vars_t *v, stp_image_t *image)
void | canon_fold_2bit (const unsigned char *line, int single_length, unsigned char *outbuf)
void | canon_fold_3bit (const unsigned char *line, int single_length, unsigned char *outbuf)
void | canon_shift_buffer (unsigned char *line, int length, int bits)
int | canon_write (stp_vars_t *v, const canon_cap_t *caps, unsigned char *line, int length, int coloridx, int ydpi, int *empty, int width, int offset, int bits)
int | print_canon_module_init (void)
int | print_canon_module_exit (void)
## Variables
const int | channel_color_map []
const int | subchannel_color_map []
const double | ink_darknesses []
const stp_dotsize_t | single_dotsize []
const stp_shade_t | canon_Cc_1bit_shades []
const stp_shade_t | canon_Mm_1bit_shades []
const stp_dotsize_t | two_bit_dotsize []
const stp_shade_t | canon_X_2bit_shades []
const stp_shade_t | canon_Xx_2bit_shades []
const stp_dotsize_t | three_bit_dotsize []
const stp_shade_t | canon_X_3bit_shades []
const stp_shade_t | canon_Xx_3bit_shades []
const canon_variable_inkset_t | ci_CMY_1
const canon_variable_inkset_t | ci_CMY_2
const canon_variable_inkset_t | ci_CMYK_1
const canon_variable_inkset_t | ci_CcMmYK_1
const canon_variable_inkset_t | ci_CMYK_2
const canon_variable_inkset_t | ci_CcMmYK_2
const canon_variable_inkset_t | ci_CMYK_3
const canon_variable_inkset_t | ci_CcMmYK_3
const canon_variable_inklist_t | canon_ink_standard []
const canon_variable_inklist_t | canon_ink_oldphoto []
const canon_variable_inklist_t | canon_ink_standardphoto []
const canon_variable_inklist_t | canon_ink_superphoto []
const char | standard_sat_adjustment []
const char | standard_lum_adjustment []
const char | standard_hue_adjustment []
const canon_cap_t | canon_model_capabilities []
const canon_res_t | canon_resolutions []
const char | plain_paper_lum_adjustment []
const paper_t | canon_paper_list []
const int | paper_type_count = sizeof(canon_paper_list) / sizeof(paper_t)
const stp_parameter_t | the_parameters []
const int | the_parameter_count
const float_param_t | float_parameters []
const int | float_parameter_count
const stp_param_string_t | media_sources []
const stp_printfuncs_t | print_canon_printfuncs
stp_family_t | print_canon_module_data
stp_module_version_t | stp_module_version = {0, 0}
stp_module_t | stp_module_data

## Define Documentation

#define CANON_CAP_a 0x04ul

| Definition at line 629 of file print-canon.c. Referenced by canon_deinit_printer(), and canon_init_setPageMode().

#define CANON_CAP_ACKSHORT 0x2000ul

| Definition at line 640 of file print-canon.c. Referenced by canon_init_resetPrinter().

#define CANON_CAP_b 0x08ul

| Definition at line 630 of file print-canon.c.

#define CANON_CAP_c 0x100ul

| Definition at line 635 of file print-canon.c. Referenced by canon_init_setColor().

#define CANON_CAP_d 0x40ul

| Definition at line 633 of file print-canon.c.

#define CANON_CAP_DMT 0x01ul /* Drop Modulation Technology */

| Definition at line 625 of file print-canon.c.

#define CANON_CAP_g 0x1000ul

| Definition at line 639 of file print-canon.c. Referenced by canon_init_setPageMargins().

#define CANON_CAP_l 0x400ul

| Definition at line 637 of file print-canon.c. Referenced by canon_init_setTray().

#define CANON_CAP_m 0x20ul

| Definition at line 632 of file print-canon.c. Referenced by canon_init_setPrintMode().

#define CANON_CAP_MSB_FIRST 0x02ul /* how to send data */

| Definition at line 627 of file print-canon.c.

#define CANON_CAP_p 0x200ul

| Definition at line 636 of file print-canon.c. Referenced by canon_init_setPageMargins2().

#define CANON_CAP_q 0x10ul

| Definition at line 631 of file print-canon.c.

#define CANON_CAP_r 0x800ul

| Definition at line 638 of file print-canon.c.

#define CANON_CAP_STD0

| Value:
    (CANON_CAP_b|CANON_CAP_c|CANON_CAP_d|\
                            CANON_CAP_l|CANON_CAP_q|CANON_CAP_t)
Definition at line 642 of file print-canon.c.

#define CANON_CAP_STD1

| Value:
    (CANON_CAP_b|CANON_CAP_c|CANON_CAP_d|CANON_CAP_l|\
                            CANON_CAP_m|CANON_CAP_p|CANON_CAP_q|CANON_CAP_t)
Definition at line 645 of file print-canon.c.

#define CANON_CAP_t 0x80ul

| Definition at line 634 of file print-canon.c. Referenced by canon_init_setImage().

#define CANON_INK | ( | A |  | ) | A,sizeof(A)/sizeof(canon_variable_inklist_t*)

| Definition at line 654 of file print-canon.c.

#define CANON_INK_BLACK_MASK (CANON_INK_K|CANON_INK_CMYK|CANON_INK_CcMmYK)

| Definition at line 614 of file print-canon.c.

#define CANON_INK_CcMmYK 8

| Definition at line 611 of file print-canon.c.

#define CANON_INK_CcMmYyK 16

| Definition at line 612 of file print-canon.c.

#define CANON_INK_CMY 2

| Definition at line 609 of file print-canon.c.

#define CANON_INK_CMYK 4

| Definition at line 610 of file print-canon.c.

#define CANON_INK_K 1

| Definition at line 608 of file print-canon.c. Referenced by canon_describe_output().

#define CANON_INK_PHOTO_MASK (CANON_INK_CcMmYK|CANON_INK_CcMmYyK)

| Definition at line 616 of file print-canon.c.

#define CANON_MODES | ( | A |  | ) | 0

| Definition at line 651 of file print-canon.c.

#define CANON_SLOT_ASF1 1

| Definition at line 619 of file print-canon.c.

#define CANON_SLOT_ASF2 2

| Definition at line 620 of file print-canon.c.

#define CANON_SLOT_MAN1 4

| Definition at line 621 of file print-canon.c.

#define CANON_SLOT_MAN2 8

| Definition at line 622 of file print-canon.c.

#define CHAR_BIT 8

| Definition at line 62 of file print-canon.c.

#define COMPBUFWIDTH

| Value:
    (MAX_PHYSICAL_BPI * MAX_OVERSAMPLED * MAX_BPP * \
            MAX_CARRIAGE_WIDTH / CHAR_BIT)
Definition at line 78 of file print-canon.c. Referenced by canon_write().

#define DECLARE_INK | ( | name,
|  | density |  | ) |

| Value:
    static const canon_variable_ink_t name##_ink =  \
    {                                               \
      density,                                      \
      name##_shades,                                \
      sizeof(name##_shades) / sizeof(stp_shade_t)   \
    }
Definition at line 240 of file print-canon.c.

#define ESC28 "\033\050"

| Definition at line 1930 of file print-canon.c. Referenced by canon_init_setColor().

#define ESC40 "\033\100"

| Definition at line 1932 of file print-canon.c.

#define ESC5b "\033\133"

| Definition at line 1931 of file print-canon.c. Referenced by canon_init_resetPrinter().

#define MAX | ( | a,
|  | b |  | ) | ((a) > (b) ? (a) : (b))

| Definition at line 82 of file print-canon.c. Referenced by internal_imageable_area().

#define MAX_BPP 4

| Definition at line 77 of file print-canon.c.

#define MAX_CARRIAGE_WIDTH 13 /* This really needs to go away */

| Definition at line 69 of file print-canon.c.

#define MAX_OVERSAMPLED 8

| Definition at line 76 of file print-canon.c.

#define MAX_PHYSICAL_BPI 1440

| Definition at line 75 of file print-canon.c.

#define MIN | ( | a,
|  | b |  | ) | (((a)<(b)) ? (a) : (b))

| Definition at line 81 of file print-canon.c. Referenced by olympus_do_print().

#define PUT | ( | WHAT,
|  | VAL,
|  | RES |  | ) |

| Value:
    stp_deprintf(STP_DBG_CANON,"canon: "WHAT\
    " is %04x =% 5d = %f\" = %f mm\n",(VAL),(VAL),(VAL)/(1.*RES),(VAL)/(RES/25.4))
Definition at line 1927 of file print-canon.c.

#define SHADE | ( | density,
|  | name |  | ) | { density, sizeof(name)/sizeof(stp_dotsize_t), name }

| Definition at line 248 of file print-canon.c.

#define stp_module_data print_canon_LTX_stp_module_data

| Definition at line 3126 of file print-canon.c.

#define stp_module_version print_canon_LTX_stp_module_version

| Definition at line 3125 of file print-canon.c.

#define USE_3BIT_FOLD_TYPE 323

| Definition at line 99 of file print-canon.c.

## Typedef Documentation

typedef struct canon_caps canon_cap_t

| Referenced by canon_describe_output(), canon_do_print(), canon_get_model_capabilities(), canon_limit(), canon_parameters(), and internal_imageable_area().

typedef struct canon_densities canon_densities_t

typedef struct canon_dot_sizes canon_dot_size_t

typedef struct canon_variable_ink canon_variable_ink_t

typedef canon_variable_inklist_t* canon_variable_inklist_p

| Definition at line 426 of file print-canon.c.

typedef struct canon_variable_inklist canon_variable_inklist_t

| Referenced by canon_inks().

typedef struct canon_variable_inkset canon_variable_inkset_t

| Referenced by canon_do_print().

## Enumeration Type Documentation

enum colormode_t

  | Enumeration values:
  COLOR_MONOCHROME |
  COLOR_CMY |
  COLOR_CMYK |
  COLOR_CCMMYK |
  COLOR_CCMMYYK |
Definition at line 546 of file print-canon.c. Referenced by canon_describe_output(), and canon_do_print().

## Function Documentation

void canon_advance_buffer | ( | unsigned char * | buf,
|  | int | len,
|  | int | num
| ) | `[static]`

| Definition at line 2268 of file print-canon.c.

void canon_cmd | ( | const stp_vars_t * | v,
|  | const char * | ini,
|  | const char | cmd,
|  | int | num,
|  |  | ...
| ) | `[static]`

| Definition at line 1897 of file print-canon.c. References stp_free(), stp_put16_le(), stp_putc(), stp_zalloc(), and stp_zfwrite(). Referenced by canon_init_resetPrinter(), and canon_init_setColor().

void canon_deinit_printer | ( | const stp_vars_t * | v,
|  | canon_init_t * | init
| ) | `[static]`

| Definition at line 2236 of file print-canon.c. References CANON_CAP_a.

double canon_density | ( | const canon_cap_t * | caps,
|  | int | res_code
| ) | `[static]`

| Definition at line 1540 of file print-canon.c. References canon_densities::d_r11, canon_densities::d_r22, canon_densities::d_r33, canon_densities::d_r43, canon_densities::d_r44, canon_densities::d_r55, canon_caps::densities, canon_caps::model, STP_DBG_CANON, and stp_deprintf().

const char* canon_describe_output | ( | const stp_vars_t * | v | ) | `[static]`

| Definition at line 1618 of file print-canon.c. References canon_cap_t, CANON_INK_K, COLOR_CMY, COLOR_CMYK, COLOR_MONOCHROME, and colormode_t.

void canon_describe_resolution | ( | const stp_vars_t * | v,
|  | int * | x,
|  | int * | y
| ) | `[static]`

| Definition at line 1598 of file print-canon.c. References canon_resolutions, canon_res_t::name, canon_res_t::name_dmt, canon_res_t::x, and canon_res_t::y.

int canon_do_print | ( | stp_vars_t * | v,
|  | stp_image_t * | image
| ) | `[static]`

| Definition at line 2319 of file print-canon.c. References canon_cap_t, canon_resolutions, canon_variable_inkset_t, colormode_t, and stp_curve_t.

int canon_end_job | ( | const stp_vars_t * | v,
|  | stp_image_t * | image
| ) | `[static]`

| Definition at line 2254 of file print-canon.c.

void canon_fold_2bit | ( | const unsigned char * | line,
|  | int | single_length,
|  | unsigned char * | outbuf
| ) | `[static]`

| Definition at line 2774 of file print-canon.c. Referenced by canon_write().

void canon_fold_3bit | ( | const unsigned char * | line,
|  | int | single_length,
|  | unsigned char * | outbuf
| ) | `[static]`

| Definition at line 2851 of file print-canon.c. Referenced by canon_write().

const canon_cap_t* canon_get_model_capabilities | ( | int | model | ) | `[static]`

| Definition at line 1358 of file print-canon.c. References canon_cap_t, canon_model_capabilities, and canon_caps::model. Referenced by canon_limit(), and internal_imageable_area().

const char* canon_hue_adjustment | ( | int | model | ) | `[static]`

| Definition at line 1526 of file print-canon.c.

void canon_imageable_area | ( | const stp_vars_t * | v,
|  | int * | left,
|  | int * | right,
|  | int * | bottom,
|  | int * | top
| ) | `[static]`

| Definition at line 1869 of file print-canon.c. References internal_imageable_area().

void canon_init_printer | ( | const stp_vars_t * | v,
|  | canon_init_t * | init
| ) | `[static]`

| Definition at line 2211 of file print-canon.c.

void canon_init_resetPrinter | ( | const stp_vars_t * | v,
|  | canon_init_t * | init
| ) | `[static]`

| Definition at line 1937 of file print-canon.c. References CANON_CAP_ACKSHORT, canon_cmd(), ESC5b, and stp_puts().

void canon_init_setColor | ( | const stp_vars_t * | v,
|  | canon_init_t * | init
| ) | `[static]`

| Definition at line 1976 of file print-canon.c. References CANON_CAP_c, canon_cmd(), ESC28, paper_t::media_code, canon_init_t::printing_color, and canon_init_t::pt.

void canon_init_setDataCompression | ( | const stp_vars_t * | v,
|  | canon_init_t * | init
| ) | `[static]`

| Definition at line 1965 of file print-canon.c.

void canon_init_setImage | ( | const stp_vars_t * | v,
|  | canon_init_t * | init
| ) | `[static]`

| Definition at line 2171 of file print-canon.c. References CANON_CAP_t, COLOR_CMY, and canon_init_t::colormode.

void canon_init_setPageID | ( | const stp_vars_t * | v,
|  | canon_init_t * | init
| ) | `[static]`

| Definition at line 2149 of file print-canon.c.

void canon_init_setPageMargins | ( | const stp_vars_t * | v,
|  | canon_init_t * | init
| ) | `[static]`

| Definition at line 2036 of file print-canon.c. References CANON_CAP_g.

void canon_init_setPageMargins2 | ( | const stp_vars_t * | v,
|  | canon_init_t * | init
| ) | `[static]`

| Definition at line 2123 of file print-canon.c. References CANON_CAP_p.

void canon_init_setPageMode | ( | const stp_vars_t * | v,
|  | canon_init_t * | init
| ) | `[static]`

| Definition at line 1953 of file print-canon.c. References CANON_CAP_a.

void canon_init_setPrintMode | ( | const stp_vars_t * | v,
|  | canon_init_t * | init
| ) | `[static]`

| Definition at line 2087 of file print-canon.c. References CANON_CAP_m.

void canon_init_setResolution | ( | const stp_vars_t * | v,
|  | canon_init_t * | init
| ) | `[static]`

| Definition at line 2023 of file print-canon.c.

void canon_init_setTray | ( | const stp_vars_t * | v,
|  | canon_init_t * | init
| ) | `[static]`

| Definition at line 2063 of file print-canon.c. References CANON_CAP_l.

void canon_init_setX72 | ( | const stp_vars_t * | v,
|  | canon_init_t * | init
| ) | `[static]`

| Definition at line 2160 of file print-canon.c.

int canon_ink_type | ( | const canon_cap_t * | caps,
|  | int | res_code
| ) | `[static]`

| Definition at line 1500 of file print-canon.c. References canon_dot_sizes::dot_r11, canon_dot_sizes::dot_r22, canon_dot_sizes::dot_r33, canon_dot_sizes::dot_r43, canon_dot_sizes::dot_r44, canon_dot_sizes::dot_r55, and canon_caps::dot_sizes.

const canon_variable_inkset_t* canon_inks | ( | const canon_cap_t * | caps,
|  | int | res_code,
|  | int | colors,
|  | int | bits
| ) | `[static]`

| Definition at line 1562 of file print-canon.c. References canon_variable_inklist::bits, canon_variable_inklist_t, canon_variable_inklist::colors, canon_variable_inklist::r11, canon_variable_inklist::r22, canon_variable_inklist::r33, canon_variable_inklist::r43, canon_variable_inklist::r44, canon_variable_inklist::r55, STP_DBG_CANON, and stp_deprintf().

void canon_limit | ( | const stp_vars_t * | v,
|  | int * | width,
|  | int * | height,
|  | int * | min_width,
|  | int * | min_height
| ) | `[static]`

| Definition at line 1879 of file print-canon.c. References canon_cap_t, canon_get_model_capabilities(), canon_caps::max_height, canon_caps::max_width, and stp_get_model_id().

stp_parameter_list_t canon_list_parameters | ( | const stp_vars_t * | v | ) | `[static]`

| Definition at line 1656 of file print-canon.c. References float_parameter_count, and the_parameter_count.

const char* canon_lum_adjustment | ( | int | model | ) | `[static]`

| Definition at line 1519 of file print-canon.c.

void canon_parameters | ( | const stp_vars_t * | v,
|  | const char * | name,
|  | stp_parameter_t * | description
| ) | `[static]`

| Definition at line 1668 of file print-canon.c. References canon_cap_t, float_parameter_count, float_parameters, and STP_PARAMETER_TYPE_INVALID.

int canon_print | ( | const stp_vars_t * | v,
|  | stp_image_t * | image
| ) | `[static]`

| Definition at line 2744 of file print-canon.c. References stp_vars_t.

void canon_printfunc | ( | stp_vars_t * | v | ) | `[static]`

| Definition at line 2282 of file print-canon.c.

colormode_t canon_printhead_colors | ( | const char * | name,
|  | const canon_cap_t * | caps
| ) | `[static]`

| Definition at line 1410 of file print-canon.c. References COLOR_CCMMYK, COLOR_CCMMYYK, COLOR_CMY, COLOR_CMYK, and COLOR_MONOCHROME.

int canon_printhead_type | ( | const char * | name,
|  | const canon_cap_t * | caps
| ) | `[static]`

| Definition at line 1387 of file print-canon.c.

int canon_res_code | ( | const canon_cap_t * | caps,
|  | int | xdpi,
|  | int | ydpi
| ) | `[static]`

| Definition at line 1463 of file print-canon.c.

const char* canon_sat_adjustment | ( | int | model | ) | `[static]`

| Definition at line 1533 of file print-canon.c.

void canon_shift_buffer | ( | unsigned char * | line,
|  | int | length,
|  | int | bits
| ) | `[static]`

| Definition at line 2953 of file print-canon.c. Referenced by canon_write().

unsigned char canon_size_type | ( | const stp_vars_t * | v,
|  | const canon_cap_t * | caps
| ) | `[static]`

| Definition at line 1433 of file print-canon.c.

int canon_source_type | ( | const char * | name,
|  | const canon_cap_t * | caps
| ) | `[static]`

| Definition at line 1372 of file print-canon.c.

int canon_start_job | ( | const stp_vars_t * | v,
|  | stp_image_t * | image
| ) | `[static]`

| Definition at line 2248 of file print-canon.c.

int canon_write | ( | stp_vars_t * | v,
|  | const canon_cap_t * | caps,
|  | unsigned char * | line,
|  | int | length,
|  | int | coloridx,
|  | int | ydpi,
|  | int * | empty,
|  | int | width,
|  | int | offset,
|  | int | bits
| ) | `[static]`

| Definition at line 2981 of file print-canon.c. References canon_fold_2bit(), canon_fold_3bit(), canon_shift_buffer(), COMPBUFWIDTH, STP_DBG_CANON, stp_deprintf(), stp_pack_tiff(), stp_put16_be(), stp_put16_le(), stp_putc(), and stp_zfwrite().

void canon_write_line | ( | stp_vars_t * | v | ) | `[static]`

| Definition at line 3076 of file print-canon.c.

DECLARE_INK | ( | canon_Xx_3bit | ,
|  | 1. | 0
| ) |

DECLARE_INK | ( | canon_X_3bit | ,
|  | 1. | 0
| ) |

DECLARE_INK | ( | canon_Xx_2bit | ,
|  | 1. | 0
| ) |

DECLARE_INK | ( | canon_X_2bit | ,
|  | 1. | 0
| ) |

DECLARE_INK | ( | canon_Mm_1bit | ,
|  | 0. | 75
| ) |

DECLARE_INK | ( | canon_Cc_1bit | ,
|  | 0. | 75
| ) |

double get_double_param | ( | stp_vars_t * | v,
|  | const char * | param
| ) | `[static]`

| Definition at line 2293 of file print-canon.c.

const paper_t* get_media_type | ( | const char * | name | ) | `[static]`

| Definition at line 1344 of file print-canon.c. References canon_paper_list, and paper_type_count.

void internal_imageable_area | ( | const stp_vars_t * | v,
|  | int | use_paper_margins,
|  | int * | left,
|  | int * | right,
|  | int * | bottom,
|  | int * | top
| ) | `[static]`

| Definition at line 1829 of file print-canon.c. References canon_caps::border_bottom, canon_caps::border_left, canon_caps::border_right, canon_caps::border_top, stp_papersize_t::bottom, canon_cap_t, canon_get_model_capabilities(), stp_papersize_t::left, MAX, stp_papersize_t::right, stp_default_media_size(), stp_get_model_id(), stp_get_papersize_by_name(), stp_get_string_parameter(), and stp_papersize_t::top.

int print_canon_module_exit | ( | void |  | ) | `[static]`

| Definition at line 3118 of file print-canon.c.

int print_canon_module_init | ( | void |  | ) | `[static]`

| Definition at line 3111 of file print-canon.c.

void set_ink_ranges | ( | stp_vars_t * | v,
|  | const canon_variable_ink_t * | ink,
|  | int | color,
|  | const char * | channel_param,
|  | const char * | subchannel_param
| ) | `[static]`

| Definition at line 2302 of file print-canon.c. References stp_channel_set_density_adjustment().

void setup_column | ( | canon_privdata_t * | privdata,
|  | int | col,
|  | int | buf_length
| ) | `[static]`

| Definition at line 2276 of file print-canon.c.

## Variable Documentation

const stp_shade_t canon_Cc_1bit_shades[]`[static]`

| Initial value:
    {
      SHADE(1.0, single_dotsize),
      SHADE(0.25, single_dotsize),
    }
Definition at line 261 of file print-canon.c.

const canon_variable_inklist_t canon_ink_oldphoto[]`[static]`

| Initial value:
    {
      {
        1,3,
        &ci_CMY_1, &ci_CMY_1, &ci_CMY_1,
        &ci_CMY_1, &ci_CMY_1, &ci_CMY_1,
      },
      {
        2,3,
        &ci_CMY_2, &ci_CMY_2,
        &ci_CMY_2, &ci_CMY_2,
        &ci_CMY_2, &ci_CMY_2,
      },
    }
Definition at line 439 of file print-canon.c.

const canon_variable_inklist_t canon_ink_standard[]`[static]`

| Initial value:
    {
      {
        1,4,
        &ci_CMYK_1, &ci_CMYK_1, &ci_CMYK_1,
        &ci_CMYK_1, &ci_CMYK_1, &ci_CMYK_1,
      },
    }
Definition at line 429 of file print-canon.c.

const canon_variable_inklist_t canon_ink_standardphoto[]`[static]`

| Initial value:
    {
      {
        1,4,
        &ci_CMYK_1, &ci_CMYK_1, &ci_CMYK_1,
        &ci_CMYK_1, &ci_CMYK_1, &ci_CMYK_1,
      },
      {
        2,4,
        &ci_CMYK_2, &ci_CMYK_2,
        &ci_CMYK_2, &ci_CMYK_2,
        &ci_CMYK_2, &ci_CMYK_2,
      },
      {
        1,6,
        &ci_CcMmYK_1, &ci_CcMmYK_1, &ci_CcMmYK_1,
        &ci_CcMmYK_1, &ci_CcMmYK_1, &ci_CcMmYK_1,
      },
      {
        2,6,
        &ci_CcMmYK_2, &ci_CcMmYK_2, &ci_CcMmYK_2,
        &ci_CcMmYK_2, &ci_CcMmYK_2, &ci_CcMmYK_2,
      },
    }
Definition at line 455 of file print-canon.c.

const canon_variable_inklist_t canon_ink_superphoto[]`[static]`

| Initial value:
    {
      {
        1,4,
        &ci_CMYK_1, &ci_CMYK_1, &ci_CMYK_1,
        &ci_CMYK_1, &ci_CMYK_1, &ci_CMYK_1,
      },
      {
        3,4,
        &ci_CMYK_3, &ci_CMYK_3, &ci_CMYK_3,
        &ci_CMYK_3, &ci_CMYK_3, &ci_CMYK_3,
      },
      {
        3,6,
        &ci_CcMmYK_3, &ci_CcMmYK_3, &ci_CcMmYK_3,
        &ci_CcMmYK_3, &ci_CcMmYK_3, &ci_CcMmYK_3,
      },
    }
Definition at line 481 of file print-canon.c.

const stp_shade_t canon_Mm_1bit_shades[]`[static]`

| Initial value:
    {
      SHADE(1.0, single_dotsize),
      SHADE(0.26, single_dotsize),
    }
Definition at line 274 of file print-canon.c.

const canon_cap_t canon_model_capabilities[]`[static]`

| Definition at line 707 of file print-canon.c. Referenced by canon_get_model_capabilities().

const paper_t canon_paper_list[]`[static]`

| Initial value:
     {
      { "Plain",            N_ ("Plain Paper"),                0x00, 0.50, 0.25, 0.500, 0, 0, 0 },
      { "Transparency",     N_ ("Transparencies"),             0x02, 1.00, 1.00, 0.900, 0, 0, 0 },
      { "BackPrint",        N_ ("Back Print Film"),            0x03, 1.00, 1.00, 0.900, 0, 0, 0 },
      { "Fabric",           N_ ("Fabric Sheets"),              0x04, 0.50, 0.25, 0.500, 0, 0, 0 },
      { "Envelope",         N_ ("Envelope"),                   0x08, 0.50, 0.25, 0.500, 0, 0, 0 },
      { "Coated",           N_ ("High Resolution Paper"),      0x07, 0.78, 0.25, 0.500, 0, 0, 0 },
      { "TShirt",           N_ ("T-Shirt Transfers"),          0x03, 0.50, 0.25, 0.500, 0, 0, 0 },
      { "GlossyFilm",       N_ ("High Gloss Film"),            0x06, 1.00, 1.00, 0.999, 0, 0, 0 },
      { "GlossyPaper",      N_ ("Glossy Photo Paper"),         0x05, 1.00, 1.00, 0.999, 0, 0, 0 },
      { "GlossyCard",       N_ ("Glossy Photo Cards"),         0x0a, 1.00, 1.00, 0.999, 0, 0, 0 },
      { "GlossyPro",        N_ ("Photo Paper Pro"),            0x09, 1.00, 1.00, 0.999, 0, 0, 0 },
      { "Other",            N_ ("Other"),                      0x00, 0.50, 0.25, .5, 0, 0, 0 },
    }
Definition at line 1204 of file print-canon.c. Referenced by get_media_type().

const canon_res_t canon_resolutions[]`[static]`

| Initial value:
     {
      { 90, 90, "90x90dpi", N_("90x90 DPI"), "90x90dmt", N_("90x90 DPI DMT") },
      { 180, 180, "180x180dpi", N_("180x180 DPI"), "180x180dmt", N_("180x180 DPI DMT") },
      { 360, 360, "360x360dpi", N_("360x360 DPI"), "360x360dmt", N_("360x360 DPI DMT") },
      { 720, 360, "720x360dpi", N_("720x360 DPI"), "720x360dmt", N_("720x360 DPI DMT") },
      { 720, 720, "720x720dpi", N_("720x720 DPI"), "720x720dmt", N_("720x720 DPI DMT") },
      { 1440, 720, "1440x720dpi", N_("1440x720 DPI"), "1440x720dmt", N_("1440x720 DPI DMT") },
      { 1440, 1440, "1440x1440dpi", N_("1440x1440 DPI"), "1440x1440dmt", N_("1440x1440 DPI DMT") },
      { 2880, 2880, "2880x2880dpi", N_("2880x2880 DPI"), "2880x2880dmt", N_("2880x2880 DPI DMT") },
      { 150, 150, "150x150dpi", N_("150x150 DPI"), "150x150dmt", N_("150x150 DPI DMT") },
      { 300, 300, "300x300dpi", N_("300x300 DPI"), "300x300dmt", N_("300x300 DPI DMT") },
      { 600, 300, "600x300dpi", N_("600x300 DPI"), "600x300dmt", N_("600x300 DPI DMT") },
      { 600, 600, "600x600dpi", N_("600x600 DPI"), "600x600dmt", N_("600x600 DPI DMT") },
      { 1200, 600, "1200x600dpi", N_("1200x600 DPI"), "1200x600dmt", N_("1200x600 DPI DMT") },
      { 1200, 1200, "1200x1200dpi", N_("1200x1200 DPI"), "1200x1200dmt", N_("1200x1200 DPI DMT") },
      { 2400, 2400, "2400x2400dpi", N_("2400x2400 DPI"), "2400x2400dmt", N_("2400x2400 DPI DMT") },
      { 0, 0, NULL, NULL, NULL, NULL }
    }
Definition at line 1142 of file print-canon.c. Referenced by canon_describe_resolution(), and canon_do_print().

const stp_shade_t canon_X_2bit_shades[]`[static]`

| Initial value:
    {

    }
Definition at line 293 of file print-canon.c.

const stp_shade_t canon_X_3bit_shades[]`[static]`

| Initial value:
    {

    }
Definition at line 333 of file print-canon.c.

const stp_shade_t canon_Xx_2bit_shades[]`[static]`

| Initial value:
    {
      SHADE(1.0, two_bit_dotsize),
      SHADE(0.33, two_bit_dotsize),
    }
Definition at line 304 of file print-canon.c.

const stp_shade_t canon_Xx_3bit_shades[]`[static]`

| Initial value:
    {
      SHADE(1.0, three_bit_dotsize),
      SHADE(0.33, three_bit_dotsize),
    }
Definition at line 344 of file print-canon.c.

const int channel_color_map[]`[static]`

| Initial value:
    {
      STP_ECOLOR_K, STP_ECOLOR_C, STP_ECOLOR_M, STP_ECOLOR_Y, STP_ECOLOR_C, STP_ECOLOR_M, STP_ECOLOR_Y
    }
Definition at line 84 of file print-canon.c.

const canon_variable_inkset_t ci_CcMmYK_1`[static]`

| Initial value:
    {
      &canon_Cc_1bit_ink,
      &canon_Mm_1bit_ink,
      NULL,
      NULL
    }
Definition at line 381 of file print-canon.c.

const canon_variable_inkset_t ci_CcMmYK_2`[static]`

| Initial value:
    {
      &canon_Xx_2bit_ink,
      &canon_Xx_2bit_ink,
      &canon_X_2bit_ink,
      &canon_X_2bit_ink
    }
Definition at line 399 of file print-canon.c.

const canon_variable_inkset_t ci_CcMmYK_3`[static]`

| Initial value:
    {
      &canon_Xx_3bit_ink,
      &canon_Xx_3bit_ink,
      &canon_X_3bit_ink,
      &canon_X_3bit_ink,
    }
Definition at line 417 of file print-canon.c.

const canon_variable_inkset_t ci_CMY_1`[static]`

| Initial value:
    {
      NULL,
      NULL,
      NULL,
      NULL
    }
Definition at line 354 of file print-canon.c.

const canon_variable_inkset_t ci_CMY_2`[static]`

| Initial value:
    {
      &canon_X_2bit_ink,
      &canon_X_2bit_ink,
      &canon_X_2bit_ink,
      NULL
    }
Definition at line 363 of file print-canon.c.

const canon_variable_inkset_t ci_CMYK_1`[static]`

| Initial value:
    {
      NULL,
      NULL,
      NULL,
      NULL
    }
Definition at line 372 of file print-canon.c.

const canon_variable_inkset_t ci_CMYK_2`[static]`

| Initial value:
    {
      &canon_X_2bit_ink,
      &canon_X_2bit_ink,
      &canon_X_2bit_ink,
      &canon_X_2bit_ink
    }
Definition at line 390 of file print-canon.c.

const canon_variable_inkset_t ci_CMYK_3`[static]`

| Initial value:
    {
      &canon_X_3bit_ink,
      &canon_X_3bit_ink,
      &canon_X_3bit_ink,
      &canon_X_3bit_ink
    }
Definition at line 408 of file print-canon.c.

const int float_parameter_count`[static]`

| Initial value:
    sizeof(float_parameters) / sizeof(const float_param_t)
Definition at line 1340 of file print-canon.c. Referenced by canon_list_parameters(), and canon_parameters().

const float_param_t float_parameters[]`[static]`

| Definition at line 1279 of file print-canon.c. Referenced by canon_parameters().

const double ink_darknesses[]`[static]`

| Initial value:
    {
      1.0, 0.31 / .5, 0.61 / .97, 0.08
    }
Definition at line 94 of file print-canon.c.

const stp_param_string_t media_sources[]`[static]`

| Initial value:
                  {
                    { "Auto",       N_ ("Auto Sheet Feeder") },
                    { "Manual",     N_ ("Manual with Pause") },
                    { "ManualNP",   N_ ("Manual without Pause") }
                  }
Definition at line 1643 of file print-canon.c.

const int paper_type_count = sizeof(canon_paper_list) / sizeof(paper_t)`[static]`

| Definition at line 1219 of file print-canon.c. Referenced by get_media_type().

const char plain_paper_lum_adjustment[]`[static]`

| Initial value:
    "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n"
    "<gimp-print>\n"
    "<curve wrap=\"wrap\" type=\"linear\" gamma=\"0\">\n"
    "<sequence count=\"48\" lower-bound=\"0\" upper-bound=\"4\">\n"
    "1.20 1.22 1.28 1.34 1.39 1.42 1.45 1.48 "
    "1.50 1.40 1.30 1.25 1.20 1.10 1.05 1.05 "
    "1.05 1.05 1.05 1.05 1.05 1.05 1.05 1.05 "
    "1.05 1.05 1.05 1.10 1.10 1.10 1.10 1.10 "
    "1.10 1.15 1.30 1.45 1.60 1.75 1.90 2.00 "
    "2.10 2.00 1.80 1.70 1.60 1.50 1.40 1.30 "
    "</sequence>\n"
    "</curve>\n"
    "</gimp-print>\n"
Definition at line 1161 of file print-canon.c.

stp_family_t print_canon_module_data`[static]`

| Initial value:
      {
        &print_canon_printfuncs,
        NULL
      }
Definition at line 3103 of file print-canon.c.

const stp_printfuncs_t print_canon_printfuncs`[static]`

| Initial value:
    {
      canon_list_parameters,
      canon_parameters,
      stp_default_media_size,
      canon_imageable_area,
      canon_limit,
      canon_print,
      canon_describe_resolution,
      canon_describe_output,
      stp_verify_printer_params,
      canon_start_job,
      canon_end_job
    }
Definition at line 2754 of file print-canon.c.

const stp_dotsize_t single_dotsize[]`[static]`

| Initial value:
    {
      { 0x1, 1.0 }
    }
Definition at line 256 of file print-canon.c.

const char standard_hue_adjustment[]`[static]`

| Initial value:
    "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n"
    "<gimp-print>\n"
    "<curve wrap=\"wrap\" type=\"linear\" gamma=\"0\">\n"
    "<sequence count=\"48\" lower-bound=\"-6\" upper-bound=\"6\">\n"
      "0.00 0.06 0.10 0.10 0.06 -.01 -.09 -.17 "
      "-.25 -.33 -.38 -.38 -.36 -.34 -.34 -.34 "
      "-.34 -.34 -.36 -.40 -.50 -.40 -.30 -.20 "
      "-.12 -.07 -.04 -.02 0.00 0.00 0.00 0.00 "
      "0.00 0.00 0.00 -.05 -.10 -.15 -.22 -.24 "
      "-.26 -.30 -.33 -.28 -.25 -.20 -.13 -.06 "
    "</sequence>\n"
    "</curve>\n"
    "</gimp-print>\n"
Definition at line 531 of file print-canon.c.

const char standard_lum_adjustment[]`[static]`

| Initial value:
    "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n"
    "<gimp-print>\n"
    "<curve wrap=\"wrap\" type=\"linear\" gamma=\"0\">\n"
    "<sequence count=\"48\" lower-bound=\"0\" upper-bound=\"4\">\n"
      "0.50 0.52 0.56 0.60 0.66 0.71 0.74 0.77 "
      "0.81 0.79 0.74 0.68 0.70 0.74 0.77 0.82 "
      "0.88 0.93 0.95 0.97 0.97 0.96 0.95 0.95 "
      "0.95 0.96 0.97 0.98 0.99 1.00 1.00 1.00 "
      "1.00 0.97 0.94 0.92 0.90 0.88 0.85 0.79 "
      "0.69 0.64 0.58 0.54 0.54 0.54 0.53 0.51 "
    "</sequence>\n"
    "</curve>\n"
    "</gimp-print>\n"
Definition at line 516 of file print-canon.c.

const char standard_sat_adjustment[]`[static]`

| Initial value:
    "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n"
    "<gimp-print>\n"
    "<curve wrap=\"wrap\" type=\"linear\" gamma=\"0\">\n"
    "<sequence count=\"48\" lower-bound=\"0\" upper-bound=\"4\">\n"
      "1.00 1.00 1.00 1.00 1.00 1.00 1.00 1.00 "
      "1.00 1.00 1.00 1.00 1.00 1.00 1.00 1.00 "
      "1.00 0.95 0.90 0.90 0.90 0.90 0.90 0.90 "
      "0.90 0.95 0.95 1.00 1.00 1.00 1.00 1.00 "
      "1.00 1.00 1.00 1.00 1.00 1.00 1.00 1.00 "
      "1.00 1.00 1.00 1.00 1.00 1.00 1.00 1.00 "
    "</sequence>\n"
    "</curve>\n"
    "</gimp-print>\n"
Definition at line 501 of file print-canon.c.

stp_module_t stp_module_data

| Initial value:
      {
        "canon",
        VERSION,
        "Canon family driver",
        STP_MODULE_CLASS_FAMILY,
        NULL,
        print_canon_module_init,
        print_canon_module_exit,
        (void *) &print_canon_module_data
      }
Definition at line 3130 of file print-canon.c.

stp_module_version_t stp_module_version = {0, 0}

| Definition at line 3128 of file print-canon.c.

const int subchannel_color_map[]`[static]`

| Initial value:
    {
      0, 0, 0, 0, 1, 1, 1
    }
Definition at line 89 of file print-canon.c.

const int the_parameter_count`[static]`

| Initial value:
    sizeof(the_parameters) / sizeof(const stp_parameter_t)
Definition at line 1267 of file print-canon.c. Referenced by canon_list_parameters().

const stp_parameter_t the_parameters[]`[static]`

| Definition at line 1221 of file print-canon.c.

const stp_dotsize_t three_bit_dotsize[]`[static]`

| Initial value:
    {
      { 0x1, 0.45 },
      { 0x2, 0.55 },
      { 0x3, 0.66 },
      { 0x4, 0.77 },
      { 0x5, 0.88 },
      { 0x6, 1.0 }
    }
Definition at line 323 of file print-canon.c.

const stp_dotsize_t two_bit_dotsize[]`[static]`

| Initial value:
    {
      { 0x1, 0.45 },
      { 0x2, 0.68 },
      { 0x3, 1.0 }
    }
Definition at line 286 of file print-canon.c.